package fowler;

import java.util.ArrayList;
import java.util.List;

public class RemoteTrack implements Track {

  private List<Artist> performers = new ArrayList<Artist>();
  
  private String title;
  
  public RemoteTrack(String title) {
    this.title = title;
  }
  
  @Override
  public void addPerformer(Artist artist) {
    performers.add(artist);
  }

  @Override
  public Artist[] getPerformers() {
   return performers.toArray(new Artist[performers.size()]);
  }

  @Override
  public String getTitle() {
    return title;
  }

  @Override
  public void removePerformer(Artist artist) {
    performers.remove(artist);
  }

  @Override
  public void setTitle(String title) {
    this.title = title;
  }

}
